clc;
clear;
import_source = 2;  %0, real data; 1 EnergyPlus data; 2 Semiprocessed data
TIME_GAP = 1;

%%  Import data
if (import_source == 0)
    % Import real data
    [indoor_temperature_seq outdoor_temperature_seq energy_seq] = Fn_ImportRawData('00.txt', TIME_GAP, 0);
    [l_indoor_temperature_seq l_outdoor_temperature_seq l_energy_seq] = Fn_ImportRawData('00.txt', TIME_GAP, 0);
elseif (import_source == 1)
    % Import data from EnergyPlus
    [indoor_temperature_seq outdoor_temperature_seq energy_seq] = Fn_ImportEnergyPlusData('energyPlusData.txt', TIME_GAP, 0);
    [l_indoor_temperature_seq l_outdoor_temperature_seq l_energy_seq] = Fn_ImportEnergyPlusData('energyPlusData_l.txt', TIME_GAP, 0);
else 
    [indoor_temperature_seq outdoor_temperature_seq energy_seq] = Fn_ImportSemiProcessedData('SemiDataPart0419.txt', TIME_GAP, 0);
    [l_indoor_temperature_seq l_outdoor_temperature_seq l_energy_seq] = Fn_ImportSemiProcessedData('SemiDataPart0419.txt', TIME_GAP, 0);
end
array_size = size(energy_seq, 2);


%% Build model
room_size = [4 3 3]; % Length, width, height.
time_seq = TIME_GAP*ones(1, array_size);

%% Predict indoor temperature change and the energy seq.
if 0
start_indoor_temp = et_model.m_denoisedIndoorTempSeq(1,1);
fixed_outdoor_temp_seq = et_model.m_To*ones(1, array_size);
predicted_IT_seq = et_model.calculateTemperatureChange(time_seq, start_indoor_temp, fixed_outdoor_temp_seq, energy_seq);
denoised_predictTempSeq = CEnergyTemperatureModel.denoiseTempData(et_model.m_timeGap, predicted_IT_seq);

revised_Energy_seq = et_model.calculateEnergySeq(time_seq, et_model.m_denoisedIndoorTempSeq, fixed_outdoor_temp_seq);
else
et_model = CEnergyIOTemperatureModel(room_size, time_seq, indoor_temperature_seq, outdoor_temperature_seq, energy_seq);
denoisedIndoorTempSeq = CEnergyIOTemperatureModel.denoiseTempData(et_model.m_timeGap, l_indoor_temperature_seq);
start_indoor_temp = denoisedIndoorTempSeq(1);
l_array_size = size(denoisedIndoorTempSeq,2);
l_time_seq = TIME_GAP*ones(1,l_array_size);
predicted_IT_seq = et_model.calculateTemperatureChange(l_time_seq, start_indoor_temp, l_outdoor_temperature_seq, l_energy_seq);
%denoised_predictTempSeq = CEnergyIOTemperatureModel.denoiseTempData(et_model.m_timeGap, predicted_IT_seq);

revised_Energy_seq = et_model.calculateEnergySeq(l_time_seq, denoisedIndoorTempSeq, l_outdoor_temperature_seq);
windowSize = 5;
%revised_Energy_seq = filter(ones(1,windowSize)/windowSize,1,revised_Energy_seq) ;   
end



time_seq = 2:2:2*l_array_size;
figure1 = figure;
hold on;
plot(time_seq, l_outdoor_temperature_seq, '-k');
plot(time_seq, denoisedIndoorTempSeq, '-b');
plot(time_seq, predicted_IT_seq, '-r');
%plot(l_time_seq, denoised_predictTempSeq, '-b');
hold off;


figure2 = figure;
hold on;
plot(time_seq, l_energy_seq, '-b');
plot(time_seq, revised_Energy_seq, '-r');
hold off;
sum(l_energy_seq)*60*TIME_GAP   %J
sum(revised_Energy_seq)*60*TIME_GAP

sum_energy_seq = zeros(1, l_array_size);
sum_energy_seq(1) = l_energy_seq(1);
sum_revised_energy_seq = zeros(1, l_array_size);
sum_revised_energy_seq(1) = revised_Energy_seq(1);

for index = 2:l_array_size
    sum_energy_seq(index)=sum_energy_seq(index-1)+ l_energy_seq(index);
    sum_revised_energy_seq(index)=sum_revised_energy_seq(index-1)+ revised_Energy_seq(index);
end
figure3 = figure;
hold on;
plot(time_seq, sum_energy_seq, '-b');
plot(time_seq, sum_revised_energy_seq, '-r');
hold off;


%% Standard deviation
temp_error = denoisedIndoorTempSeq - predicted_IT_seq;
Temp_Std_deviation = std(temp_error)

energy_error = l_energy_seq - revised_Energy_seq;
Energy_Std_deviation = std(energy_error)

